﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _125839
{
    public partial class Form1 : Form
    {
        DataSet ds;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ds = new DataSet();
            DataTable dt1 = ds.Tables.Add("table1");
            DataTable dt2 = ds.Tables.Add("table2");

            dt1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            for (int i = 0; i < 5; i++)
            {
                dt1.Columns.Add(string.Format("col{0}", i), typeof(string)).DefaultValue = "Table1";
            }

            dt2.Columns.Add("pid", typeof(int));
            dt2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            
            for (int i = 0; i < 5; i++)
            {
                dt2.Columns.Add(string.Format("col{0}", i), typeof(string)).DefaultValue = "Table2";
            }

            ds.Relations.Add(dt1.Columns["id"], dt2.Columns["pid"]);

            for (int i = 0; i < 5; i++)
            {
                DataRow row = dt1.Rows.Add();
                for (int j = 0; j < 5; j++)
                {
                    dt2.Rows.Add(row["id"]);
                }
            }

            ultraGrid1.DataSource = ds;
            ultraGrid1.Rows.ExpandAll(true);

        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraGrid1.BeginUpdate();
            DataTable dt1 = ds.Tables["table1"];
            DataTable dt2 = ds.Tables["table2"];
            for (int i = 0; i < 5; i++)
            {
                dt1.Rows[i]["col0"] = "updated";
                dt1.Rows[i]["col1"] = "updated";
                dt1.Rows[i]["col3"] = "updated";

                dt2.Rows[i]["col0"] = "updated";
                dt2.Rows[i]["col1"] = "updated";
                dt2.Rows[i]["col2"] = "updated";
                dt2.Rows[i]["col3"] = "updated";
                dt2.Rows[i]["col4"] = "updated";
            }
            ultraGrid1.EndUpdate();
        }
    }
}
